﻿@using Services;
@inject ConvertService convertService

<div>
    <EditForm Model="@DummyModel">
        <div class="form-group">
            <h6>Intrest amount = Principal amount * No of years * Rate of Intrest</h6>
        </div>
        <div class="form-group">
            <table class="table table-hover table-sm">
                <tbody>
                    <tr>
                        <td>Amount per year</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@SelectedType.Amount" checked="@(SelectType == SelectedType.Amount)" @onchange="__e => SelectType = SelectedType.Amount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerYear" @oninput="((ChangeEventArgs __e) => AmountPerYear = ToDouble(__e?.Value))" disabled="@(SelectType == SelectedType.Amount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Amount per month</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@SelectedType.Amount" checked="@(SelectType == SelectedType.Amount)" @onchange="__e => SelectType = SelectedType.Amount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@AmountPerMonth" @oninput="((ChangeEventArgs __e) => AmountPerMonth = ToDouble(__e?.Value))" disabled="@(SelectType == SelectedType.Amount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Interest %</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@SelectedType.Interest" checked="@(SelectType == SelectedType.Interest)" @onchange="__e => SelectType = SelectedType.Interest" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@Interest" @oninput="((ChangeEventArgs __e) => Interest = ToDouble(__e?.Value))" disabled="@(SelectType == SelectedType.Interest)" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>No of years</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@SelectedType.Time" checked="@(SelectType == SelectedType.Time)" @onchange="__e => SelectType = SelectedType.Time" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@NoOfYears" @oninput="((ChangeEventArgs __e) => NoOfYears = ToDouble(__e?.Value))" disabled="@(SelectType == SelectedType.Time)" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>No of months</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@SelectedType.Time" checked="@(SelectType == SelectedType.Time)" @onchange="__e => SelectType = SelectedType.Time" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@NoOfMonths" @oninput="((ChangeEventArgs __e) => NoOfMonths = ToDouble(__e?.Value))" disabled="@(SelectType == SelectedType.Time)" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Interest per year</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@SelectedType.InterestAmount" checked="@(SelectType == SelectedType.InterestAmount)" @onchange="__e => SelectType = SelectedType.InterestAmount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@InterestPerYear" @oninput="((ChangeEventArgs __e) => InterestPerYear = ToDouble(__e?.Value))" disabled="@(SelectType == SelectedType.InterestAmount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Interest per month</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@SelectedType.InterestAmount" checked="@(SelectType == SelectedType.InterestAmount)" @onchange="__e => SelectType = SelectedType.InterestAmount" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@InterestPerMonth" @oninput="((ChangeEventArgs __e) => InterestPerMonth = ToDouble(__e?.Value))" disabled="@(SelectType == SelectedType.InterestAmount)" maxlength="12" />
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </EditForm>
</div>

@code {

    private string DummyModel { get; set; } = string.Empty;

    private const int MonthInYear = 12;

    private enum SelectedType { Amount, Interest, Time, InterestAmount };
    private SelectedType SelectType { get; set; } = SelectedType.InterestAmount;

    private double amountPerYear = 0;
    private double AmountPerYear
    {
        get { return amountPerYear; }
        set
        {
            amountPerYear = value;
            amountPerMonth = Math.Round(value / MonthInYear, 2);
        }
    }

    private double amountPerMonth = 0;
    private double AmountPerMonth
    {
        get { return amountPerMonth; }
        set
        {
            amountPerMonth = value;
            amountPerYear = value * MonthInYear;
        }
    }

    private double Interest { get; set; } = 0;

    private double noOfYears = 0;
    private double NoOfYears
    {
        get { return noOfYears; }
        set
        {
            noOfYears = value;
            noOfMonths = value * MonthInYear;
        }
    }
    private double noOfMonths = 0;
    private double NoOfMonths
    {
        get { return noOfMonths; }
        set
        {
            noOfMonths = value;
            noOfYears = Math.Round(value / MonthInYear, 2);
        }
    }

    private double interestPerYear = 0;
    private double InterestPerYear
    {
        get { return interestPerYear; }
        set
        {
            interestPerYear = value;
            interestPerMonth = Math.Round(value / MonthInYear, 2);
        }
    }
    private double interestPerMonth = 0;
    private double InterestPerMonth
    {
        get { return interestPerMonth; }
        set
        {
            interestPerMonth = value;
            interestPerYear = value * MonthInYear;
        }
    }

    protected override bool ShouldRender()
    {
        RefreshValues();
        bool shouldRender = base.ShouldRender();
        return shouldRender;
    }

    private double ToDouble(object value) => convertService.ToDouble(value);

    private string ToIndianCurrency(double value) => convertService.ToIndianCurrency(value, false, false);

    private void RefreshValues()
    {
        PreFilter();
        Calculate();
    }

    private void PreFilter()
    {
        if (AmountPerYear < 0) AmountPerYear = 0;
        if (AmountPerMonth < 0) AmountPerMonth = 0;
        if (Interest < 0) Interest = 0;
        if (NoOfYears < 0) NoOfYears = 0;
        if (NoOfMonths < 0) NoOfMonths = 0;
        if (InterestPerYear < 0) InterestPerYear = 0;
    }

    private void Calculate()
    {
        switch (SelectType)
        {
            case SelectedType.Amount:
                if (Interest <= 0 || NoOfYears <= 0) AmountPerYear = 0;
                else AmountPerYear = Math.Round(InterestPerYear * (100 / Interest) / NoOfYears, 2);
                break;
            case SelectedType.Interest:
                if (AmountPerYear <= 0 || NoOfYears <= 0) Interest = 0;
                else Interest = Math.Round(InterestPerYear / (AmountPerYear * NoOfYears) * 100, 2);
                break;
            case SelectedType.Time:
                if (AmountPerYear <= 0 || Interest <= 0) NoOfYears = 0;
                else NoOfYears = Math.Round(InterestPerYear / AmountPerYear * (100 / Interest));
                break;
            case SelectedType.InterestAmount:
                InterestPerYear = Math.Round(AmountPerYear * NoOfYears * (Interest / 100), 2);
                break;
            default:
                throw new NotImplementedException();
        }
    }

}
